// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

mod api;
pub use api::BlockingWrite;
pub use api::BlockingWriter;
pub use api::Write;
pub use api::WriteExt;
pub use api::WriteOperation;
pub use api::Writer;

mod compose_write;
pub use compose_write::ThreeWaysWriter;
pub use compose_write::TwoWaysWriter;

mod multipart_upload_write;
pub use multipart_upload_write::MultipartUploadPart;
pub use multipart_upload_write::MultipartUploadWrite;
pub use multipart_upload_write::MultipartUploadWriter;

mod append_object_write;
pub use append_object_write::AppendObjectWrite;
pub use append_object_write::AppendObjectWriter;

mod one_shot_write;
pub use one_shot_write::OneShotWrite;
pub use one_shot_write::OneShotWriter;

mod exact_buf_write;
pub use exact_buf_write::ExactBufWriter;

mod range_write;
pub use range_write::RangeWrite;
pub use range_write::RangeWriter;
